diff -ur --unidirectional-new-file /usr/src/usr.sbin/inetd/inetd.c /usr/src-new/usr.sbin/inetd/inetd.c
--- /usr/src/usr.sbin/inetd/inetd.c	2006-01-13 14:26:46.000000000 -0600
+++ /usr/src-new/usr.sbin/inetd/inetd.c	2006-06-20 11:11:04.000000000 -0500
@@ -160,971 +245,727 @@
 #ifndef LIBWRAP_DENY_SEVERITY
 # define LIBWRAP_DENY_SEVERITY LOG_WARNING
 #endif
-
-#define ISWRAP(sep)	\
-	   ( ((wrap_ex && !(sep)->se_bi) || (wrap_bi && (sep)->se_bi)) \
-	&& (sep->se_family == AF_INET || sep->se_family == AF_INET6) \
-	&& ( ((sep)->se_accept && (sep)->se_socktype == SOCK_STREAM) \
-	    || (sep)->se_socktype == SOCK_DGRAM))
-
-#ifdef LOGIN_CAP
-#include <login_cap.h>
-
-/* see init.c */
-#define RESOURCE_RC "daemon"
-
-#endif
-
-#ifndef	MAXCHILD
-#define	MAXCHILD	-1		/* maximum number of this service
-					   < 0 = no limit */
-#endif
-
-#ifndef	MAXCPM
-#define	MAXCPM		-1		/* rate limit invocations from a
-					   single remote address,
-					   < 0 = no limit */
-#endif
-
-#ifndef	MAXPERIP
-#define	MAXPERIP	-1		/* maximum number of this service
-					   from a single remote address,
-					   < 0 = no limit */
+int allow_severity = LIBWRAP_ALLOW_FACILITY|LIBWRAP_ALLOW_SEVERITY;
+int deny_severity = LIBWRAP_DENY_FACILITY|LIBWRAP_DENY_SEVERITY;
 #endif
 
-#ifndef TOOMANY
-#define	TOOMANY		256		/* don't start more than TOOMANY */
-#endif
+#define	TOOMANY		40		/* don't start more than TOOMANY */
 #define	CNT_INTVL	60		/* servers in CNT_INTVL sec. */
 #define	RETRYTIME	(60*10)		/* retry after bind or server fail */
-#define MAX_MAXCHLD	32767		/* max allowable max children */
 
-#define	SIGBLOCK	(sigmask(SIGCHLD)|sigmask(SIGHUP)|sigmask(SIGALRM))
+#define	A_CNT(a)	(sizeof (a) / sizeof (a[0]))
 
-void		close_sep(struct servtab *);
-void		flag_signal(int);
-void		flag_config(int);
-void		config(void);
-int		cpmip(const struct servtab *, int);
-void		endconfig(void);
-struct servtab *enter(struct servtab *);
-void		freeconfig(struct servtab *);
-struct servtab *getconfigent(void);
-int		matchservent(const char *, const char *, const char *);
-char	       *nextline(FILE *);
-void		addchild(struct servtab *, int);
-void		flag_reapchild(int);
-void		reapchild(void);
-void		enable(struct servtab *);
-void		disable(struct servtab *);
-void		flag_retry(int);
-void		retry(void);
-int		setconfig(void);
-void		setup(struct servtab *);
-#ifdef IPSEC
-void		ipsecsetup(struct servtab *);
+int	debug;
+#ifdef LIBWRAP
+int	lflag;
 #endif
-void		unregisterrpc(struct servtab *sep);
-static struct conninfo *search_conn(struct servtab *sep, int ctrl);
-static int	room_conn(struct servtab *sep, struct conninfo *conn);
-static void	addchild_conn(struct conninfo *conn, pid_t pid);
-static void	reapchild_conn(pid_t pid);
-static void	free_conn(struct conninfo *conn);
-static void	resize_conn(struct servtab *sep, int maxperip);
-static void	free_connlist(struct servtab *sep);
-static void	free_proc(struct procinfo *);
-static struct procinfo *search_proc(pid_t pid, int add);
-static int	hashval(char *p, int len);
-
-int	allow_severity;
-int	deny_severity;
-int	wrap_ex = 0;
-int	wrap_bi = 0;
-int	debug = 0;
-int	log = 0;
-int	maxsock;			/* highest-numbered descriptor */
-fd_set	allsock;
+int	maxsock;
+int	kq;
 int	options;
 int	timingout;
-int	toomany = TOOMANY;
-int	maxchild = MAXCHILD;
-int	maxcpm = MAXCPM;
-int	maxperip = MAXPERIP;
 struct	servent *sp;
-struct	rpcent *rpc;
-char	*hostname = NULL;
-struct	sockaddr_in *bind_sa4;
-int	no_v4bind = 1;
-#ifdef INET6
-struct	sockaddr_in6 *bind_sa6;
-int	no_v6bind = 1;
+char	*curdom;
+const int niflags = NI_NUMERICHOST | NI_NUMERICSERV;
+
+#ifndef OPEN_MAX
+#define OPEN_MAX	64
 #endif
-int	signalpipe[2];
-#ifdef SANITY_CHECK
-int	nsock;
+
+/* Reserve some descriptors, 3 stdio + at least: 1 log, 1 conf. file */
+#define FD_MARGIN	(8)
+rlim_t		rlim_ofile_cur = OPEN_MAX;
+
+#ifdef RLIMIT_NOFILE
+struct rlimit	rlim_ofile;
+#endif
+
+struct kevent	changebuf[64];
+size_t		changes;
+
+struct	servtab {
+	char	*se_hostaddr;		/* host address to listen on */
+	char	*se_service;		/* name of service */
+	int	se_socktype;		/* type of socket to use */
+	int	se_family;		/* address family */
+	char	*se_proto;		/* protocol used */
+	int	se_sndbuf;		/* sndbuf size */
+	int	se_rcvbuf;		/* rcvbuf size */
+	int	se_rpcprog;		/* rpc program number */
+	int	se_rpcversl;		/* rpc program lowest version */
+	int	se_rpcversh;		/* rpc program highest version */
+#define isrpcservice(sep)	((sep)->se_rpcversl != 0)
+	pid_t	se_wait;		/* single threaded server */
+	short	se_checked;		/* looked at during merge */
+	char	*se_user;		/* user name to run as */
+	char	*se_group;		/* group name to run as */
+	struct	biltin *se_bi;		/* if built-in, description */
+	char	*se_server;		/* server program */
+#define	MAXARGV 20
+	char	*se_argv[MAXARGV+1];	/* program arguments */
+#ifdef IPSEC
+	char	*se_policy;		/* IPsec poilcy string */
 #endif
-uid_t	euid;
-gid_t	egid;
-mode_t	mask;
+	int	se_fd;			/* open descriptor */
+	int	se_type;		/* type */
+	union {
+		struct	sockaddr se_un_ctrladdr;
+		struct	sockaddr_in se_un_ctrladdr_in;
+		struct	sockaddr_in6 se_un_ctrladdr_in6;
+		struct	sockaddr_un se_un_ctrladdr_un;
+	} se_un;			/* bound address */
+#define se_ctrladdr	se_un.se_un_ctrladdr
+#define se_ctrladdr_in	se_un.se_un_ctrladdr_in
+#define se_ctrladdr_un	se_un.se_un_ctrladdr_un
+	int	se_ctrladdr_size;
+	int	se_max;			/* max # of instances of this service */
+	int	se_count;		/* number started since se_time */
+	struct	timeval se_time;	/* start of se_count */
+#ifdef MULOG
+	int	se_log;
+#define MULOG_RFC931	0x40000000
+#endif
+	struct	servtab *se_next;
+} *servtab;
+
+#define NORM_TYPE	0
+#define MUX_TYPE	1
+#define MUXPLUS_TYPE	2
+#define FAITH_TYPE	3
+#define ISMUX(sep)	(((sep)->se_type == MUX_TYPE) || \
+			 ((sep)->se_type == MUXPLUS_TYPE))
+#define ISMUXPLUS(sep)	((sep)->se_type == MUXPLUS_TYPE)
+
+
+static void	chargen_dg(int, struct servtab *);
+static void	chargen_stream(int, struct servtab *);
+static void	close_sep(struct servtab *);
+static void	config(void);
+static void	daytime_dg(int, struct servtab *);
+static void	daytime_stream(int, struct servtab *);
+static void	discard_dg(int, struct servtab *);
+static void	discard_stream(int, struct servtab *);
+static void	echo_dg(int, struct servtab *);
+static void	echo_stream(int, struct servtab *);
+static void	endconfig(void);
+static struct servtab *enter(struct servtab *);
+static void	freeconfig(struct servtab *);
+static struct servtab *getconfigent(void);
+static void	goaway(void);
+static void	machtime_dg(int, struct servtab *);
+static void	machtime_stream(int, struct servtab *);
+static char    *newstr(char *);
+static char    *nextline(FILE *);
+static void	print_service(char *, struct servtab *);
+static void	reapchild(void);
+static void	retry(void);
+static void	run_service(int, struct servtab *);
+static int	setconfig(void);
+static void	setup(struct servtab *);
+static char    *sskip(char **);
+static char    *skip(char **);
+static void	tcpmux(int, struct servtab *);
+static void	usage(void);
+static void	register_rpc(struct servtab *);
+static void	unregister_rpc(struct servtab *);
+static void	bump_nofile(void);
+static void	inetd_setproctitle(char *, int);
+static void	initring(void);
+static uint32_t	machtime(void);
+static int	port_good_dg(struct sockaddr *);
+static int 	dg_broadcast(struct in_addr *);
+static int	my_kevent(const struct kevent *, size_t, struct kevent *,
+		size_t);
+static struct kevent *	allocchange(void);
+static int	getline(int, char *, int);
+static void	spawn(struct servtab *, int);
+#ifdef MULOG
+static void	dolog(struct servtab *, int);
+static void	timeout(int);
+static char    *rfc931_name(struct sockaddr *, int);
+#endif
+
+struct biltin {
+	char	*bi_service;		/* internally provided service name */
+	int	bi_socktype;		/* type of socket supported */
+	short	bi_fork;		/* 1 if should fork before call */
+	short	bi_wait;		/* 1 if should wait for child */
+	void	(*bi_fn)(int, struct servtab *);
+					/* function which performs it */
+} biltins[] = {
+	/* Echo received data */
+	{ "echo",	SOCK_STREAM,	1, 0,	echo_stream },
+	{ "echo",	SOCK_DGRAM,	0, 0,	echo_dg },
+
+	/* Internet /dev/null */
+	{ "discard",	SOCK_STREAM,	1, 0,	discard_stream },
+	{ "discard",	SOCK_DGRAM,	0, 0,	discard_dg },
+
+	/* Return 32 bit time since 1970 */
+	{ "time",	SOCK_STREAM,	0, 0,	machtime_stream },
+	{ "time",	SOCK_DGRAM,	0, 0,	machtime_dg },
+
+	/* Return human-readable time */
+	{ "daytime",	SOCK_STREAM,	0, 0,	daytime_stream },
+	{ "daytime",	SOCK_DGRAM,	0, 0,	daytime_dg },
+
+	/* Familiar character generator */
+	{ "chargen",	SOCK_STREAM,	1, 0,	chargen_stream },
+	{ "chargen",	SOCK_DGRAM,	0, 0,	chargen_dg },
+
+	{ "tcpmux",	SOCK_STREAM,	1, 0,	tcpmux },
+
+	{ NULL }
+};
+
+/* list of "bad" ports. I.e. ports that are most obviously used for
+ * "cycling packets" denial of service attacks. See /etc/services.
+ * List must end with port number "0".
+ */
 
-struct	servtab *servtab;
+u_int16_t bad_ports[] =  { 7, 9, 13, 19, 37, 0 };
 
-extern struct biltin biltins[];
 
 #define NUMINT	(sizeof(intab) / sizeof(struct inent))
-const char	*CONFIG = _PATH_INETDCONF;
-const char	*pid_file = _PATH_INETDPID;
+char	*CONFIG = _PATH_INETDCONF;
 
-static LIST_HEAD(, procinfo) proctable[PERIPSIZE];
+static int my_signals[] =
+    { SIGALRM, SIGHUP, SIGCHLD, SIGTERM, SIGINT, SIGPIPE };
 
 int
-getvalue(const char *arg, int *value, const char *whine)
-{
-	int  tmp;
-	char *p;
-
-	tmp = strtol(arg, &p, 0);
-	if (tmp < 0 || *p) {
-		syslog(LOG_ERR, whine, arg);
-		return 1;			/* failure */
-	}
-	*value = tmp;
-	return 0;				/* success */
-}
-
-static sa_family_t
-whichaf(struct request_info *req)
+main(int argc, char *argv[])
 {
-	struct sockaddr *sa;
-
-	sa = (struct sockaddr *)req->client->sin;
-	if (sa == NULL)
-		return AF_UNSPEC;
-	if (sa->sa_family == AF_INET6 &&
-	    IN6_IS_ADDR_V4MAPPED(&((struct sockaddr_in6 *)sa)->sin6_addr))
-		return AF_INET;
-	return sa->sa_family;
-}
+	int		ch, n, reload = 1;
 
-int
-main(int argc, char **argv)
-{
-	struct servtab *sep;
-	struct passwd *pwd;
-	struct group *grp;
-	struct sigaction sa, saalrm, sachld, sahup, sapipe;
-	int ch, dofork;
-	pid_t pid;
-	char buf[50];
-#ifdef LOGIN_CAP
-	login_cap_t *lc = NULL;
+	while ((ch = getopt(argc, argv,
+#ifdef LIBWRAP
+					"dl"
+#else
+					"d"
 #endif
-	struct request_info req;
-	int denied;
-	char *service = NULL;
-	union {
-		struct sockaddr peer_un;
-		struct sockaddr_in peer_un4;
-		struct sockaddr_in6 peer_un6;
-		struct sockaddr_storage peer_max;
-	} p_un;
-#define peer	p_un.peer_un
-#define peer4	p_un.peer_un4
-#define peer6	p_un.peer_un6
-#define peermax	p_un.peer_max
-	int i;
-	struct addrinfo hints, *res;
-	const char *servname;
-	int error;
-	struct conninfo *conn;
-
-	openlog("inetd", LOG_PID | LOG_NOWAIT | LOG_PERROR, LOG_DAEMON);
-
-	while ((ch = getopt(argc, argv, "dlwWR:a:c:C:p:s:")) != -1)
+					   )) != -1)
 		switch(ch) {
 		case 'd':
 			debug = 1;
 			options |= SO_DEBUG;
 			break;
+#ifdef LIBWRAP
 		case 'l':
-			log = 1;
-			break;
-		case 'R':
-			getvalue(optarg, &toomany,
-				"-R %s: bad value for service invocation rate");
-			break;
-		case 'c':
-			getvalue(optarg, &maxchild,
-				"-c %s: bad value for maximum children");
-			break;
-		case 'C':
-			getvalue(optarg, &maxcpm,
-				"-C %s: bad value for maximum children/minute");
-			break;
-		case 'a':
-			hostname = optarg;
-			break;
-		case 'p':
-			pid_file = optarg;
-			break;
-		case 's':
-			getvalue(optarg, &maxperip,
-				"-s %s: bad value for maximum children per source address");
-			break;
-		case 'w':
-			wrap_ex++;
-			break;
-		case 'W':
-			wrap_bi++;
+			lflag = 1;
 			break;
+#endif
 		case '?':
 		default:
-			syslog(LOG_ERR,
-				"usage: inetd [-dlwW] [-a address] [-R rate]"
-				" [-c maximum] [-C rate]"
-				" [-p pidfile] [conf-file]");
-			exit(EX_USAGE);
+			usage();
 		}
-	/*
-	 * Initialize Bind Addrs.
-	 *   When hostname is NULL, wild card bind addrs are obtained from
-	 *   getaddrinfo(). But getaddrinfo() requires at least one of
-	 *   hostname or servname is non NULL.
-	 *   So when hostname is NULL, set dummy value to servname.
-	 */
-	servname = (hostname == NULL) ? "discard" /* dummy */ : NULL;
+	argc -= optind;
+	argv += optind;
+
+	if (argc > 0)
+		CONFIG = argv[0];
 
-	bzero(&hints, sizeof(struct addrinfo));
-	hints.ai_flags = AI_PASSIVE;
-	hints.ai_family = AF_UNSPEC;
-	error = getaddrinfo(hostname, servname, &hints, &res);
-	if (error != 0) {
-		syslog(LOG_ERR, "-a %s: %s", hostname, gai_strerror(error));
-		if (error == EAI_SYSTEM)
-			syslog(LOG_ERR, "%s", strerror(errno));
-		exit(EX_USAGE);
+	if (!debug)
+		daemon(0, 0);
+	openlog("inetd", LOG_PID | LOG_NOWAIT, LOG_DAEMON);
+	pidfile(NULL);
+
+	kq = kqueue();
+	if (kq < 0) {
+		syslog(LOG_ERR, "kqueue: %m");
+		return (EXIT_FAILURE);
 	}
-	do {
-		if (res->ai_addr == NULL) {
-			syslog(LOG_ERR, "-a %s: getaddrinfo failed", hostname);
-			exit(EX_USAGE);
-		}
-		switch (res->ai_addr->sa_family) {
-		case AF_INET:
-			if (no_v4bind == 0)
-				continue;
-			bind_sa4 = (struct sockaddr_in *)res->ai_addr;
-			/* init port num in case servname is dummy */
-			bind_sa4->sin_port = 0;
-			no_v4bind = 0;
-			continue;
-#ifdef INET6
-		case AF_INET6:
-			if (no_v6bind == 0)
-				continue;
-			bind_sa6 = (struct sockaddr_in6 *)res->ai_addr;
-			/* init port num in case servname is dummy */
-			bind_sa6->sin6_port = 0;
-			no_v6bind = 0;
-			continue;
-#endif
-		}
-		if (no_v4bind == 0
-#ifdef INET6
-		    && no_v6bind == 0
-#endif
-		    )
-			break;
-	} while ((res = res->ai_next) != NULL);
-	if (no_v4bind != 0
-#ifdef INET6
-	    && no_v6bind != 0
-#endif
-	    ) {
-		syslog(LOG_ERR, "-a %s: unknown address family", hostname);
-		exit(EX_USAGE);
+
+#ifdef RLIMIT_NOFILE
+	if (getrlimit(RLIMIT_NOFILE, &rlim_ofile) < 0) {
+		syslog(LOG_ERR, "getrlimit: %m");
+	} else {
+		rlim_ofile_cur = rlim_ofile.rlim_cur;
+		if (rlim_ofile_cur == RLIM_INFINITY)	/* ! */
+			rlim_ofile_cur = OPEN_MAX;
 	}
+#endif
 
-	euid = geteuid();
-	egid = getegid();
-	umask(mask = umask(0777));
+	for (n = 0; n < A_CNT(my_signals); n++) {
+		int	signum;
 
-	argc -= optind;
-	argv += optind;
+		signum = my_signals[n];
+		if (signum != SIGCHLD)
+			(void) signal(signum, SIG_IGN);
 
-	if (argc > 0)
-		CONFIG = argv[0];
-	if (debug == 0) {
-		FILE *fp;
-		if (daemon(0, 0) < 0) {
-			syslog(LOG_WARNING, "daemon(0,0) failed: %m");
-		}
-		/* From now on we don't want syslog messages going to stderr. */
-		closelog();
-		openlog("inetd", LOG_PID | LOG_NOWAIT, LOG_DAEMON);
-		/*
-		 * In case somebody has started inetd manually, we need to
-		 * clear the logname, so that old servers run as root do not
-		 * get the user's logname..
-		 */
-		if (setlogin("") < 0) {
-			syslog(LOG_WARNING, "cannot clear logname: %m");
-			/* no big deal if it fails.. */
-		}
-		pid = getpid();
-		fp = fopen(pid_file, "w");
-		if (fp) {
-			fprintf(fp, "%ld\n", (long)pid);
-			fclose(fp);
-		} else {
-			syslog(LOG_WARNING, "%s: %m", pid_file);
+		if (signum != SIGPIPE) {
+			struct kevent	*ev;
+
+			ev = allocchange();
+			EV_SET(ev, signum, EVFILT_SIGNAL, EV_ADD | EV_ENABLE,
+			    0, 0, 0);
 		}
 	}
-	for (i = 0; i < PERIPSIZE; ++i)
-		LIST_INIT(&proctable[i]);
-	sa.sa_flags = 0;
-	sigemptyset(&sa.sa_mask);
-	sigaddset(&sa.sa_mask, SIGALRM);
-	sigaddset(&sa.sa_mask, SIGCHLD);
-	sigaddset(&sa.sa_mask, SIGHUP);
-	sa.sa_handler = flag_retry;
-	sigaction(SIGALRM, &sa, &saalrm);
-	config();
-	sa.sa_handler = flag_config;
-	sigaction(SIGHUP, &sa, &sahup);
-	sa.sa_handler = flag_reapchild;
-	sigaction(SIGCHLD, &sa, &sachld);
-	sa.sa_handler = SIG_IGN;
-	sigaction(SIGPIPE, &sa, &sapipe);
-
-	{
-		/* space for daemons to overwrite environment for ps */
-#define	DUMMYSIZE	100
-		char dummy[DUMMYSIZE];
-
-		memset(dummy, 'x', DUMMYSIZE - 1);
-		dummy[DUMMYSIZE - 1] = '\0';
-		if (setenv("inetd_dummy", dummy, 1) == -1)
-			syslog(LOG_WARNING, "setenv: cannot set inetd_dummy=%s: %m", dummy);
-		
-	}
-
-	if (pipe(signalpipe) != 0) {
-		syslog(LOG_ERR, "pipe: %m");
-		exit(EX_OSERR);
-	}
-	if (fcntl(signalpipe[0], F_SETFD, FD_CLOEXEC) < 0 ||
-	    fcntl(signalpipe[1], F_SETFD, FD_CLOEXEC) < 0) {
-		syslog(LOG_ERR, "signalpipe: fcntl (F_SETFD, FD_CLOEXEC): %m");
-		exit(EX_OSERR);
-	}
-	FD_SET(signalpipe[0], &allsock);
-#ifdef SANITY_CHECK
-	nsock++;
-#endif
-	if (signalpipe[0] > maxsock)
-	    maxsock = signalpipe[0];
-	if (signalpipe[1] > maxsock)
-	    maxsock = signalpipe[1];
 
 	for (;;) {
-	    int n, ctrl;
-	    fd_set readable;
+		int		ctrl;
+		struct kevent	eventbuf[64], *ev;
+		struct servtab	*sep;
 
-#ifdef SANITY_CHECK
-	    if (nsock == 0) {
-		syslog(LOG_ERR, "%s: nsock=0", __func__);
-		exit(EX_SOFTWARE);
-	    }
-#endif
-	    readable = allsock;
-	    if ((n = select(maxsock + 1, &readable, (fd_set *)0,
-		(fd_set *)0, (struct timeval *)0)) <= 0) {
-		    if (n < 0 && errno != EINTR) {
-			syslog(LOG_WARNING, "select: %m");
-			sleep(1);
-		    }
-		    continue;
-	    }
-	    /* handle any queued signal flags */
-	    if (FD_ISSET(signalpipe[0], &readable)) {
-		int nsig;
-		if (ioctl(signalpipe[0], FIONREAD, &nsig) != 0) {
-		    syslog(LOG_ERR, "ioctl: %m");
-		    exit(EX_OSERR);
-		}
-		while (--nsig >= 0) {
-		    char c;
-		    if (read(signalpipe[0], &c, 1) != 1) {
-			syslog(LOG_ERR, "read: %m");
-			exit(EX_OSERR);
-		    }
-		    if (debug)
-			warnx("handling signal flag %c", c);
-		    switch(c) {
-		    case 'A': /* sigalrm */
-			retry();
-			break;
-		    case 'C': /* sigchld */
-			reapchild();
-			break;
-		    case 'H': /* sighup */
+		if (reload) {
+			reload = 0;
 			config();
-			break;
-		    }
 		}
-	    }
-	    for (sep = servtab; n && sep; sep = sep->se_next)
-	        if (sep->se_fd != -1 && FD_ISSET(sep->se_fd, &readable)) {
-		    n--;
-		    if (debug)
-			    warnx("someone wants %s", sep->se_service);
-		    dofork = !sep->se_bi || sep->se_bi->bi_fork || ISWRAP(sep);
-		    conn = NULL;
-		    if (sep->se_accept && sep->se_socktype == SOCK_STREAM) {
-			    i = 1;
-			    if (ioctl(sep->se_fd, FIONBIO, &i) < 0)
-				    syslog(LOG_ERR, "ioctl (FIONBIO, 1): %m");
-			    ctrl = accept(sep->se_fd, (struct sockaddr *)0,
-				(socklen_t *)0);
-			    if (debug)
-				    warnx("accept, ctrl %d", ctrl);
-			    if (ctrl < 0) {
-				    if (errno != EINTR)
-					    syslog(LOG_WARNING,
-						"accept (for %s): %m",
-						sep->se_service);
-                                      if (sep->se_accept &&
-                                          sep->se_socktype == SOCK_STREAM)
-                                              close(ctrl);
-				    continue;
-			    }
-			    i = 0;
-			    if (ioctl(sep->se_fd, FIONBIO, &i) < 0)
-				    syslog(LOG_ERR, "ioctl1(FIONBIO, 0): %m");
-			    if (ioctl(ctrl, FIONBIO, &i) < 0)
-				    syslog(LOG_ERR, "ioctl2(FIONBIO, 0): %m");
-			    if (cpmip(sep, ctrl) < 0) {
-				close(ctrl);
+
+		n = my_kevent(changebuf, changes, eventbuf, A_CNT(eventbuf));
+		changes = 0;
+
+		for (ev = eventbuf; n > 0; ev++, n--) {
+			if (ev->filter == EVFILT_SIGNAL) {
+				switch (ev->ident) {
+				case SIGALRM:
+					retry();
+					break;
+				case SIGCHLD:
+					reapchild();
+					break;
+				case SIGTERM:
+				case SIGINT:
+					goaway();
+					break;
+				case SIGHUP:
+					reload = 1;
+					break;
+				}
 				continue;
-			    }
-			    if (dofork &&
-				(conn = search_conn(sep, ctrl)) != NULL &&
-				!room_conn(sep, conn)) {
-				close(ctrl);
+			}
+			if (ev->filter != EVFILT_READ)
 				continue;
-			    }
-		    } else
-			    ctrl = sep->se_fd;
-		    if (log && !ISWRAP(sep)) {
-			    char pname[INET6_ADDRSTRLEN] = "unknown";
-			    socklen_t sl;
-			    sl = sizeof peermax;
-			    if (getpeername(ctrl, (struct sockaddr *)
-					    &peermax, &sl)) {
-				    sl = sizeof peermax;
-				    if (recvfrom(ctrl, buf, sizeof(buf),
-					MSG_PEEK,
-					(struct sockaddr *)&peermax,
-					&sl) >= 0) {
-				      getnameinfo((struct sockaddr *)&peermax,
-						  peer.sa_len,
-						  pname, sizeof(pname),
-						  NULL, 0, 
-						  NI_NUMERICHOST|
-						  NI_WITHSCOPEID);
-				    }
-			    } else {
-			            getnameinfo((struct sockaddr *)&peermax,
-						peer.sa_len,
-						pname, sizeof(pname),
-						NULL, 0, 
-						NI_NUMERICHOST|
-						NI_WITHSCOPEID);
-			    }
-			    syslog(LOG_INFO,"%s from %s", sep->se_service, pname);
-		    }
-		    sigblock(SIGBLOCK);
-		    pid = 0;
-		    /*
-		     * Fork for all external services, builtins which need to
-		     * fork and anything we're wrapping (as wrapping might
-		     * block or use hosts_options(5) twist).
-		     */
-		    if (dofork) {
-			    if (sep->se_count++ == 0)
-				gettimeofday(&sep->se_time, (struct timezone *)NULL);
-			    else if (toomany > 0 && sep->se_count >= toomany) {
-				struct timeval now;
-
-				gettimeofday(&now, (struct timezone *)NULL);
-				if (now.tv_sec - sep->se_time.tv_sec >
-				    CNT_INTVL) {
-					sep->se_time = now;
-					sep->se_count = 1;
-				} else {
-					syslog(LOG_ERR,
-			"%s/%s server failing (looping), service terminated",
-					    sep->se_service, sep->se_proto);
-					if (sep->se_accept &&
-					    sep->se_socktype == SOCK_STREAM)
-						close(ctrl);
-					close_sep(sep);
-					free_conn(conn);
-					sigsetmask(0L);
-					if (!timingout) {
-						timingout = 1;
-						alarm(RETRYTIME);
-					}
-					continue;
-				}
-			    }
-			    pid = fork();
-		    }
-		    if (pid < 0) {
-			    syslog(LOG_ERR, "fork: %m");
-			    if (sep->se_accept &&
-				sep->se_socktype == SOCK_STREAM)
-				    close(ctrl);
-			    free_conn(conn);
-			    sigsetmask(0L);
-			    sleep(1);
-			    continue;
-		    }
-		    if (pid) {
-			addchild_conn(conn, pid);
-			addchild(sep, pid);
-		    }
-		    sigsetmask(0L);
-		    if (pid == 0) {
-			    if (dofork) {
-				sigaction(SIGALRM, &saalrm, (struct sigaction *)0);
-				sigaction(SIGCHLD, &sachld, (struct sigaction *)0);
-				sigaction(SIGHUP, &sahup, (struct sigaction *)0);
-				/* SIGPIPE reset before exec */
-			    }
-			    /*
-			     * Call tcpmux to find the real service to exec.
-			     */
-			    if (sep->se_bi &&
-				sep->se_bi->bi_fn == (bi_fn_t *) tcpmux) {
-				    sep = tcpmux(ctrl);
-				    if (sep == NULL) {
-					    close(ctrl);
-					    _exit(0);
-				    }
-			    }
-			    if (ISWRAP(sep)) {
-				inetd_setproctitle("wrapping", ctrl);
-				service = sep->se_server_name ?
-				    sep->se_server_name : sep->se_service;
-				request_init(&req, RQ_DAEMON, service, RQ_FILE, ctrl, NULL);
-				fromhost(&req);
-				deny_severity = LIBWRAP_DENY_FACILITY|LIBWRAP_DENY_SEVERITY;
-				allow_severity = LIBWRAP_ALLOW_FACILITY|LIBWRAP_ALLOW_SEVERITY;
-				denied = !hosts_access(&req);
-				if (denied) {
-				    syslog(deny_severity,
-				        "refused connection from %.500s, service %s (%s%s)",
-				        eval_client(&req), service, sep->se_proto,
-					(whichaf(&req) == AF_INET6) ? "6" : "");
-				    if (sep->se_socktype != SOCK_STREAM)
-					recv(ctrl, buf, sizeof (buf), 0);
-				    if (dofork) {
-					sleep(1);
-					_exit(0);
-				    }
-				}
-				if (log) {
-				    syslog(allow_severity,
-				        "connection from %.500s, service %s (%s%s)",
-					eval_client(&req), service, sep->se_proto,
-					(whichaf(&req) == AF_INET6) ? "6" : "");
-				}
-			    }
-			    if (sep->se_bi) {
-				(*sep->se_bi->bi_fn)(ctrl, sep);
-			    } else {
+			sep = (struct servtab *)ev->udata;
+			/* Paranoia */
+			if (ev->ident != sep->se_fd)
+				continue;
+			if (debug)
+				fprintf(stderr, "someone wants %s\n",
+				    sep->se_service);
+			if (!sep->se_wait && sep->se_socktype == SOCK_STREAM) {
+				/* XXX here do the libwrap check-before-accept*/
+				ctrl = accept(sep->se_fd, NULL, NULL);
 				if (debug)
-					warnx("%d execl %s",
-						getpid(), sep->se_server);
-				/* Clear close-on-exec. */
-				if (fcntl(ctrl, F_SETFD, 0) < 0) {
-					syslog(LOG_ERR,
-					    "%s/%s: fcntl (F_SETFD, 0): %m",
-						sep->se_service, sep->se_proto);
-					_exit(EX_OSERR);
-				}
-				if (ctrl != 0) {
-					dup2(ctrl, 0);
-					close(ctrl);
-				}
-				dup2(0, 1);
-				dup2(0, 2);
-				if ((pwd = getpwnam(sep->se_user)) == NULL) {
-					syslog(LOG_ERR,
-					    "%s/%s: %s: no such user",
-						sep->se_service, sep->se_proto,
-						sep->se_user);
-					if (sep->se_socktype != SOCK_STREAM)
-						recv(0, buf, sizeof (buf), 0);
-					_exit(EX_NOUSER);
-				}
-				grp = NULL;
-				if (   sep->se_group != NULL
-				    && (grp = getgrnam(sep->se_group)) == NULL
-				   ) {
-					syslog(LOG_ERR,
-					    "%s/%s: %s: no such group",
-						sep->se_service, sep->se_proto,
-						sep->se_group);
-					if (sep->se_socktype != SOCK_STREAM)
-						recv(0, buf, sizeof (buf), 0);
-					_exit(EX_NOUSER);
-				}
-				if (grp != NULL)
-					pwd->pw_gid = grp->gr_gid;
-#ifdef LOGIN_CAP
-				if ((lc = login_getclass(sep->se_class)) == NULL) {
-					/* error syslogged by getclass */
-					syslog(LOG_ERR,
-					    "%s/%s: %s: login class error",
-						sep->se_service, sep->se_proto,
-						sep->se_class);
-					if (sep->se_socktype != SOCK_STREAM)
-						recv(0, buf, sizeof (buf), 0);
-					_exit(EX_NOUSER);
-				}
-#endif
-				if (setsid() < 0) {
-					syslog(LOG_ERR,
-						"%s: can't setsid(): %m",
-						 sep->se_service);
-					/* _exit(EX_OSERR); not fatal yet */
-				}
-#ifdef LOGIN_CAP
-				if (setusercontext(lc, pwd, pwd->pw_uid,
-				    LOGIN_SETALL) != 0) {
-					syslog(LOG_ERR,
-					 "%s: can't setusercontext(..%s..): %m",
-					 sep->se_service, sep->se_user);
-					_exit(EX_OSERR);
-				}
-				login_close(lc);
-#else
-				if (pwd->pw_uid) {
-					if (setlogin(sep->se_user) < 0) {
-						syslog(LOG_ERR,
-						 "%s: can't setlogin(%s): %m",
-						 sep->se_service, sep->se_user);
-						/* _exit(EX_OSERR); not yet */
-					}
-					if (setgid(pwd->pw_gid) < 0) {
-						syslog(LOG_ERR,
-						  "%s: can't set gid %d: %m",
-						  sep->se_service, pwd->pw_gid);
-						_exit(EX_OSERR);
-					}
-					initgroups(pwd->pw_name,
-							pwd->pw_gid);
-					if (setuid(pwd->pw_uid) < 0) {
-						syslog(LOG_ERR,
-						  "%s: can't set uid %d: %m",
-						  sep->se_service, pwd->pw_uid);
-						_exit(EX_OSERR);
-					}
+					fprintf(stderr, "accept, ctrl %d\n",
+					    ctrl);
+				if (ctrl < 0) {
+					if (errno != EINTR)
+						syslog(LOG_WARNING,
+						    "accept (for %s): %m",
+						    sep->se_service);
+					continue;
 				}
-#endif
-				sigaction(SIGPIPE, &sapipe,
-				    (struct sigaction *)0);
-				execv(sep->se_server, sep->se_argv);
-				syslog(LOG_ERR,
-				    "cannot execute %s: %m", sep->se_server);
-				if (sep->se_socktype != SOCK_STREAM)
-					recv(0, buf, sizeof (buf), 0);
-			    }
-			    if (dofork)
-				_exit(0);
-		    }
-		    if (sep->se_accept && sep->se_socktype == SOCK_STREAM)
-			    close(ctrl);
+			} else
+				ctrl = sep->se_fd;
+			spawn(sep, ctrl);
 		}
 	}
 }
 
-/*
- * Add a signal flag to the signal flag queue for later handling
- */
-
-void
-flag_signal(int c)
+static void
+spawn(struct servtab *sep, int ctrl)
 {
-	char ch = c;
+	int dofork;
+	pid_t pid;
+
+	pid = 0;
+#ifdef LIBWRAP_INTERNAL
+	dofork = 1;
+#else
+	dofork = (sep->se_bi == 0 || sep->se_bi->bi_fork);
+#endif
+	if (dofork) {
+		if (sep->se_count++ == 0)
+			(void)gettimeofday(&sep->se_time, NULL);
+		else if (sep->se_count >= sep->se_max) {
+			struct timeval now;
+
+			(void)gettimeofday(&now, NULL);
+			if (now.tv_sec - sep->se_time.tv_sec > CNT_INTVL) {
+				sep->se_time = now;
+				sep->se_count = 1;
+			} else {
+				syslog(LOG_ERR,
+				    "%s/%s max spawn rate (%d in %d seconds) "
+				    "exceeded; service not started",
+				    sep->se_service, sep->se_proto,
+				    sep->se_max, CNT_INTVL);
+				if (!sep->se_wait && sep->se_socktype ==
+				    SOCK_STREAM)
+					close(ctrl);
+				close_sep(sep);
+				if (!timingout) {
+					timingout = 1;
+					alarm(RETRYTIME);
+				}
+				return;
+			}
+		}
+		pid = fork();
+		if (pid < 0) {
+			syslog(LOG_ERR, "fork: %m");
+			if (!sep->se_wait && sep->se_socktype == SOCK_STREAM)
+				close(ctrl);
+			sleep(1);
+			return;
+		}
+		if (pid != 0 && sep->se_wait) {
+			struct kevent	*ev;
 
-	if (write(signalpipe[1], &ch, 1) != 1) {
-		syslog(LOG_ERR, "write: %m");
-		_exit(EX_OSERR);
+			sep->se_wait = pid;
+			ev = allocchange();
+			EV_SET(ev, sep->se_fd, EVFILT_READ,
+			    EV_DELETE, 0, 0, 0);
+		}
+		if (pid == 0) {
+			int	n;
+
+			for (n = 0; n < A_CNT(my_signals); n++)
+				(void) signal(my_signals[n], SIG_DFL);
+			if (debug)
+				setsid();
+		}
 	}
+	if (pid == 0) {
+		run_service(ctrl, sep);
+		if (dofork)
+			exit(0);
+	}
+	if (!sep->se_wait && sep->se_socktype == SOCK_STREAM)
+		close(ctrl);
 }
 
-/*
- * Record a new child pid for this service. If we've reached the
- * limit on children, then stop accepting incoming requests.
- */
-
-void
-addchild(struct servtab *sep, pid_t pid)
+static void
+run_service(int ctrl, struct servtab *sep)
 {
-	if (sep->se_maxchild <= 0)
-		return;
-#ifdef SANITY_CHECK
-	if (sep->se_numchild >= sep->se_maxchild) {
-		syslog(LOG_ERR, "%s: %d >= %d",
-		    __func__, sep->se_numchild, sep->se_maxchild);
-		exit(EX_SOFTWARE);
-	}
+	struct passwd *pwd;
+	struct group *grp = NULL;	/* XXX gcc */
+	char buf[NI_MAXSERV];
+#ifdef LIBWRAP
+	struct request_info req;
+	int denied;
+	char *service = NULL;	/* XXX gcc */
 #endif
-	sep->se_pids[sep->se_numchild++] = pid;
-	if (sep->se_numchild == sep->se_maxchild)
-		disable(sep);
-}
 
-/*
- * Some child process has exited. See if it's on somebody's list.
- */
+#ifdef LIBWRAP
+#ifndef LIBWRAP_INTERNAL
+	if (sep->se_bi == 0)
+#endif
+	if (!sep->se_wait && sep->se_socktype == SOCK_STREAM) {
+		request_init(&req, RQ_DAEMON, sep->se_argv[0] ?
+		    sep->se_argv[0] : sep->se_service, RQ_FILE, ctrl, NULL);
+		fromhost(&req);
+		denied = !hosts_access(&req);
+		if (denied || lflag) {
+			if (getnameinfo(&sep->se_ctrladdr,
+					sep->se_ctrladdr.sa_len, NULL, 0,
+					buf, sizeof(buf), 0) != 0) {
+				/* shouldn't happen */
+				(void)snprintf(buf, sizeof buf, "%d",
+				    ntohs(sep->se_ctrladdr_in.sin_port));
+			}
+			service = buf;
+		}
+		if (denied) {
+			syslog(deny_severity,
+			    "refused connection from %.500s, service %s (%s)",
+			    eval_client(&req), service, sep->se_proto);
+			goto reject;
+		}
+		if (lflag) {
+			syslog(allow_severity,
+			    "connection from %.500s, service %s (%s)",
+			    eval_client(&req), service, sep->se_proto);
+		}
+	}
+#endif /* LIBWRAP */
 
-void
-flag_reapchild(int signo __unused)
-{
-	flag_signal('C');
+	if (sep->se_bi) {
+		(*sep->se_bi->bi_fn)(ctrl, sep);
+	} else {
+		if ((pwd = getpwnam(sep->se_user)) == NULL) {
+			syslog(LOG_ERR, "%s/%s: %s: No such user",
+			    sep->se_service, sep->se_proto, sep->se_user);
+			goto reject;
+		}
+		if (sep->se_group &&
+		    (grp = getgrnam(sep->se_group)) == NULL) {
+			syslog(LOG_ERR, "%s/%s: %s: No such group",
+			    sep->se_service, sep->se_proto, sep->se_group);
+			goto reject;
+		}
+		if (pwd->pw_uid) {
+			if (sep->se_group)
+				pwd->pw_gid = grp->gr_gid;
+			if (setgid(pwd->pw_gid) < 0) {
+				syslog(LOG_ERR,
+				 "%s/%s: can't set gid %d: %m", sep->se_service,
+				    sep->se_proto, pwd->pw_gid);
+				goto reject;
+			}
+			(void) initgroups(pwd->pw_name,
+			    pwd->pw_gid);
+			if (setuid(pwd->pw_uid) < 0) {
+				syslog(LOG_ERR,
+				 "%s/%s: can't set uid %d: %m", sep->se_service,
+				    sep->se_proto, pwd->pw_uid);
+				goto reject;
+			}
+		} else if (sep->se_group) {
+			(void) setgid((gid_t)grp->gr_gid);
+		}
+		if (debug)
+			fprintf(stderr, "%d execl %s\n",
+			    getpid(), sep->se_server);
+#ifdef MULOG
+		if (sep->se_log)
+			dolog(sep, ctrl);
+#endif
+		/* Set our control descriptor to not close-on-exec... */
+		if (fcntl(ctrl, F_SETFD, 0) < 0)
+			syslog(LOG_ERR, "fcntl (F_SETFD, 0): %m");
+		/* ...and dup it to stdin, stdout, and stderr. */
+		if (ctrl != 0) {
+			dup2(ctrl, 0);
+			close(ctrl);
+			ctrl = 0;
+		}
+		dup2(0, 1);
+		dup2(0, 2);
+#ifdef RLIMIT_NOFILE
+		if (rlim_ofile.rlim_cur != rlim_ofile_cur &&
+		    setrlimit(RLIMIT_NOFILE, &rlim_ofile) < 0)
+			syslog(LOG_ERR, "setrlimit: %m");
+#endif
+		execv(sep->se_server, sep->se_argv);
+		syslog(LOG_ERR, "cannot execute %s: %m", sep->se_server);
+	reject:
+		if (sep->se_socktype != SOCK_STREAM)
+			recv(ctrl, buf, sizeof (buf), 0);
+		_exit(1);
+	}
 }
 
-void
+static void
 reapchild(void)
 {
-	int k, status;
+	int status;
 	pid_t pid;
 	struct servtab *sep;
 
 	for (;;) {
-		pid = wait3(&status, WNOHANG, (struct rusage *)0);
+		pid = wait3(&status, WNOHANG, NULL);
 		if (pid <= 0)
 			break;
 		if (debug)
-			warnx("%d reaped, %s %u", pid,
-			    WIFEXITED(status) ? "status" : "signal",
-			    WIFEXITED(status) ? WEXITSTATUS(status)
-				: WTERMSIG(status));
-		for (sep = servtab; sep; sep = sep->se_next) {
-			for (k = 0; k < sep->se_numchild; k++)
-				if (sep->se_pids[k] == pid)
-					break;
-			if (k == sep->se_numchild)
-				continue;
-			if (sep->se_numchild == sep->se_maxchild)
-				enable(sep);
-			sep->se_pids[k] = sep->se_pids[--sep->se_numchild];
-			if (WIFSIGNALED(status) || WEXITSTATUS(status))
-				syslog(LOG_WARNING,
-				    "%s[%d]: exited, %s %u",
-				    sep->se_server, pid,
-				    WIFEXITED(status) ? "status" : "signal",
-				    WIFEXITED(status) ? WEXITSTATUS(status)
-					: WTERMSIG(status));
-			break;
-		}
-		reapchild_conn(pid);
+			(void) fprintf(stderr, "%d reaped, status %#x\n", 
+			    pid, status);
+		for (sep = servtab; sep != NULL; sep = sep->se_next)
+			if (sep->se_wait == pid) {
+				struct kevent	*ev;
+
+				if (WIFEXITED(status) && WEXITSTATUS(status))
+					syslog(LOG_WARNING,
+					    "%s: exit status 0x%x",
+					    sep->se_server, WEXITSTATUS(status));
+				else if (WIFSIGNALED(status))
+					syslog(LOG_WARNING,
+					    "%s: exit signal 0x%x",
+					    sep->se_server, WTERMSIG(status));
+				sep->se_wait = 1;
+				ev = allocchange();
+				EV_SET(ev, sep->se_fd, EVFILT_READ,
+				    EV_ADD | EV_ENABLE, 0, 0, (intptr_t)sep);
+				if (debug)
+					fprintf(stderr, "restored %s, fd %d\n",
+					    sep->se_service, sep->se_fd);
+			}
 	}
 }
 
-void
-flag_config(int signo __unused)
-{
-	flag_signal('H');
-}
-
-void
+static void
 config(void)
 {
-	struct servtab *sep, *new, **sepp;
-	long omask;
-#ifdef LOGIN_CAP
-	login_cap_t *lc = NULL;
-#endif
-
+	struct servtab *sep, *cp, **sepp;
+	int n;
 
 	if (!setconfig()) {
 		syslog(LOG_ERR, "%s: %m", CONFIG);
 		return;
 	}
-	for (sep = servtab; sep; sep = sep->se_next)
+	for (sep = servtab; sep != NULL; sep = sep->se_next)
 		sep->se_checked = 0;
-	while ((new = getconfigent())) {
-		if (getpwnam(new->se_user) == NULL) {
-			syslog(LOG_ERR,
-				"%s/%s: no such user '%s', service ignored",
-				new->se_service, new->se_proto, new->se_user);
-			continue;
-		}
-		if (new->se_group && getgrnam(new->se_group) == NULL) {
-			syslog(LOG_ERR,
-				"%s/%s: no such group '%s', service ignored",
-				new->se_service, new->se_proto, new->se_group);
-			continue;
-		}
-#ifdef LOGIN_CAP
-		if ((lc = login_getclass(new->se_class)) == NULL) {
-			/* error syslogged by getclass */
-			syslog(LOG_ERR,
-				"%s/%s: %s: login class error, service ignored",
-				new->se_service, new->se_proto, new->se_class);
-			continue;
-		}
-		login_close(lc);
-#endif
-		for (sep = servtab; sep; sep = sep->se_next)
-			if (strcmp(sep->se_service, new->se_service) == 0 &&
-			    strcmp(sep->se_proto, new->se_proto) == 0 &&
-			    sep->se_socktype == new->se_socktype &&
-			    sep->se_family == new->se_family)
+	while ((cp = getconfigent())) {
+		for (sep = servtab; sep != NULL; sep = sep->se_next)
+			if (strcmp(sep->se_service, cp->se_service) == 0 &&
+			    strcmp(sep->se_hostaddr, cp->se_hostaddr) == 0 &&
+			    strcmp(sep->se_proto, cp->se_proto) == 0 &&
+			    ISMUX(sep) == ISMUX(cp))
 				break;
-		if (sep != 0) {
+		if (sep != NULL) {
 			int i;
 
-#define SWAP(a, b) { typeof(a) c = a; a = b; b = c; }
-			omask = sigblock(SIGBLOCK);
-			if (sep->se_nomapped != new->se_nomapped) {
-				sep->se_nomapped = new->se_nomapped;
-				sep->se_reset = 1;
-			}
-			/* copy over outstanding child pids */
-			if (sep->se_maxchild > 0 && new->se_maxchild > 0) {
-				new->se_numchild = sep->se_numchild;
-				if (new->se_numchild > new->se_maxchild)
-					new->se_numchild = new->se_maxchild;
-				memcpy(new->se_pids, sep->se_pids,
-				    new->se_numchild * sizeof(*new->se_pids));
-			}
-			SWAP(sep->se_pids, new->se_pids);
-			sep->se_maxchild = new->se_maxchild;
-			sep->se_numchild = new->se_numchild;
-			sep->se_maxcpm = new->se_maxcpm;
-			resize_conn(sep, new->se_maxperip);
-			sep->se_maxperip = new->se_maxperip;
-			sep->se_bi = new->se_bi;
-			/* might need to turn on or off service now */
-			if (sep->se_fd >= 0) {
-			      if (sep->se_maxchild > 0
-				  && sep->se_numchild == sep->se_maxchild) {
-				      if (FD_ISSET(sep->se_fd, &allsock))
-					  disable(sep);
-			      } else {
-				      if (!FD_ISSET(sep->se_fd, &allsock))
-					  enable(sep);
-			      }
-			}
-			sep->se_accept = new->se_accept;
-			SWAP(sep->se_user, new->se_user);
-			SWAP(sep->se_group, new->se_group);
-#ifdef LOGIN_CAP
-			SWAP(sep->se_class, new->se_class);
-#endif
-			SWAP(sep->se_server, new->se_server);
-			SWAP(sep->se_server_name, new->se_server_name);
+#define SWAP(type, a, b) {type c = a; a = b; b = c;}
+
+			/*
+			 * sep->se_wait may be holding the pid of a daemon
+			 * that we're waiting for.  If so, don't overwrite
+			 * it unless the config file explicitly says don't
+			 * wait.
+			 */
+			if (cp->se_bi == 0 &&
+			    (sep->se_wait == 1 || cp->se_wait == 0))
+				sep->se_wait = cp->se_wait;
+			SWAP(char *, sep->se_user, cp->se_user);
+			SWAP(char *, sep->se_group, cp->se_group);
+			SWAP(char *, sep->se_server, cp->se_server);
 			for (i = 0; i < MAXARGV; i++)
-				SWAP(sep->se_argv[i], new->se_argv[i]);
+				SWAP(char *, sep->se_argv[i], cp->se_argv[i]);
 #ifdef IPSEC
-			SWAP(sep->se_policy, new->se_policy);
-			ipsecsetup(sep);
+			SWAP(char *, sep->se_policy, cp->se_policy);
 #endif
-			sigsetmask(omask);
-			freeconfig(new);
+			SWAP(int, cp->se_type, sep->se_type);
+			SWAP(int, cp->se_max, sep->se_max);
+#undef SWAP
+			if (isrpcservice(sep))
+				unregister_rpc(sep);
+			sep->se_rpcversl = cp->se_rpcversl;
+			sep->se_rpcversh = cp->se_rpcversh;
+			freeconfig(cp);
 			if (debug)
 				print_service("REDO", sep);
 		} else {
-			sep = enter(new);
+			sep = enter(cp);
 			if (debug)
 				print_service("ADD ", sep);
 		}
 		sep->se_checked = 1;
-		if (ISMUX(sep)) {
-			sep->se_fd = -1;
-			continue;
-		}
+
 		switch (sep->se_family) {
-		case AF_INET:
-			if (no_v4bind != 0) {
-				sep->se_fd = -1;
+		case AF_LOCAL:
+			if (sep->se_fd != -1)
+				break;
+			n = strlen(sep->se_service);
+			if (n > sizeof(sep->se_ctrladdr_un.sun_path)) {
+				syslog(LOG_ERR, "%s: address too long",
+				    sep->se_service);
+				sep->se_checked = 0;
 				continue;
 			}
+			(void)unlink(sep->se_service);
+			strncpy(sep->se_ctrladdr_un.sun_path,
+			    sep->se_service, n);
+			sep->se_ctrladdr_un.sun_family = AF_LOCAL;
+			sep->se_ctrladdr_size = n +
+			    sizeof(sep->se_ctrladdr_un) -
+			    sizeof(sep->se_ctrladdr_un.sun_path);
+			if (!ISMUX(sep))
+				setup(sep);
 			break;
+		case AF_INET:
 #ifdef INET6
 		case AF_INET6:
-			if (no_v6bind != 0) {
-				sep->se_fd = -1;
+#endif
+		    {
+			struct addrinfo hints, *res;
+			char *host, *port;
+			int error;
+			int s;
+
+			/* check if the family is supported */
+			s = socket(sep->se_family, SOCK_DGRAM, 0);
+			if (s < 0) {
+				syslog(LOG_WARNING,
+				    "%s/%s: %s: the address family is not "
+				    "supported by the kernel",
+				    sep->se_service, sep->se_proto,
+				    sep->se_hostaddr);
+				sep->se_checked = 0;
 				continue;
 			}
-			break;
-#endif
-		}
-		if (!sep->se_rpc) {
-			if (sep->se_family != AF_UNIX) {
-				sp = getservbyname(sep->se_service, sep->se_proto);
-				if (sp == 0) {
-					syslog(LOG_ERR, "%s/%s: unknown service",
-					sep->se_service, sep->se_proto);
-					sep->se_checked = 0;
-					continue;
+			close(s);
+
+			memset(&hints, 0, sizeof(hints));
+			hints.ai_family = sep->se_family;
+			hints.ai_socktype = sep->se_socktype;
+			hints.ai_flags = AI_PASSIVE;
+			if (!strcmp(sep->se_hostaddr, "*"))
+				host = NULL;
+			else
+				host = sep->se_hostaddr;
+			if (isrpcservice(sep) || ISMUX(sep))
+				port = "0";
+			else
+				port = sep->se_service;
+			error = getaddrinfo(host, port, &hints, &res);
+			if (error) {
+				if (error == EAI_SERVICE) {
+					/* gai_strerror not friendly enough */
+					syslog(LOG_WARNING, "%s/%s: "
+					    "unknown service",
+					    sep->se_service, sep->se_proto);
+				} else {
+					syslog(LOG_ERR, "%s/%s: %s: %s",
+					    sep->se_service, sep->se_proto,
+					    sep->se_hostaddr,
+					    gai_strerror(error));
 				}
+				sep->se_checked = 0;
+				continue;
 			}
-			switch (sep->se_family) {
-			case AF_INET:
-				if (sp->s_port != sep->se_ctrladdr4.sin_port) {
-					sep->se_ctrladdr4.sin_port =
-						sp->s_port;
-					sep->se_reset = 1;
-				}
-				break;
-#ifdef INET6
-			case AF_INET6:
-				if (sp->s_port !=
-				    sep->se_ctrladdr6.sin6_port) {
-					sep->se_ctrladdr6.sin6_port =
-						sp->s_port;
-					sep->se_reset = 1;
-				}
-				break;
-#endif
+			if (res->ai_next) {
+				syslog(LOG_ERR,
+					"%s/%s: %s: resolved to multiple addr",
+				    sep->se_service, sep->se_proto,
+				    sep->se_hostaddr);
+				sep->se_checked = 0;
+				freeaddrinfo(res);
+				continue;
 			}
-			if (sep->se_reset != 0 && sep->se_fd >= 0)
-				close_sep(sep);
-		} else {
-			rpc = getrpcbyname(sep->se_service);
-			if (rpc == 0) {
-				syslog(LOG_ERR, "%s/%s unknown RPC service",
-					sep->se_service, sep->se_proto);
-				if (sep->se_fd != -1)
-					close(sep->se_fd);
+			memcpy(&sep->se_ctrladdr, res->ai_addr,
+				res->ai_addrlen);
+			if (ISMUX(sep)) {
 				sep->se_fd = -1;
-					continue;
+				freeaddrinfo(res);
+				continue;
 			}
-			if (rpc->r_number != sep->se_rpc_prog) {
-				if (sep->se_rpc_prog)
-					unregisterrpc(sep);
-				sep->se_rpc_prog = rpc->r_number;
+			sep->se_ctrladdr_size = res->ai_addrlen;
+			freeaddrinfo(res);
+#ifdef RPC
+			if (isrpcservice(sep)) {
+				struct rpcent *rp;
+
+				sep->se_rpcprog = atoi(sep->se_service);
+				if (sep->se_rpcprog == 0) {
+					rp = getrpcbyname(sep->se_service);
+					if (rp == 0) {
+						syslog(LOG_ERR,
+						    "%s/%s: unknown service",
+						    sep->se_service,
+						    sep->se_proto);
+						sep->se_checked = 0;
+						continue;
+					}
+					sep->se_rpcprog = rp->r_number;
+				}
+				if (sep->se_fd == -1 && !ISMUX(sep))
+					setup(sep);
 				if (sep->se_fd != -1)
-					close(sep->se_fd);
-				sep->se_fd = -1;
+					register_rpc(sep);
+			} else
+#endif
+			{
+				if (sep->se_fd >= 0)
+					close_sep(sep);
+				if (sep->se_fd == -1 && !ISMUX(sep))
+					setup(sep);
 			}
+		    }
 		}
-		if (sep->se_fd == -1)
-			setup(sep);
 	}
 	endconfig();
 	/*
 	 * Purge anything not looked at above.
 	 */
-	omask = sigblock(SIGBLOCK);
 	sepp = &servtab;
 	while ((sep = *sepp)) {
 		if (sep->se_checked) {
